/*
    Copyright 2009 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl-2.0.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

typedef unsigned char   u8;



#define VER         "0.1"



int doit(u8 *name);
int regkeyr(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, DWORD len);
int fulltilt_pwd(u8 *pwd, int pwdlen);



int main(void) {
    int     done;

    fputs("\n"
        "Full Tilt Poker password decrypter "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    done = 0;
    if(!doit("Username")) done++;
    if(!doit("Password")) done++;
    if(!done) printf("- no encrypted strings found in the registry\n");

    printf("\n  Press RETURN to exit\n");
    fgetc(stdin);
    return(0);
}



int doit(u8 *name) {
    int     len;
    u8      buff[256];

    len = regkeyr(HKEY_CURRENT_USER, "Software\\Full Tilt Poker\\UserInfo", name, buff, sizeof(buff));
    if(len < 0) return(-1);
    if(!fulltilt_pwd(buff, len)) {
        printf("  %s: %s\n", name, buff);
    } else {
        printf("- the %s can't be decrypted\n", name);
    }
    return(0);
}



int regkeyr(HKEY hKey, LPCTSTR lpSubKey, LPTSTR lpValueName, char *buff, DWORD len) {
    HKEY    key;

    buff[0] = 0;
    if(RegOpenKeyEx(hKey, lpSubKey, 0, KEY_READ, &key) != ERROR_SUCCESS) {
        return(-1);
    }
    if(RegQueryValueEx(key, lpValueName, NULL, REG_NONE, buff, &len) != ERROR_SUCCESS) {
        RegCloseKey(key);
        return(-1);
    }
    RegCloseKey(key);
    buff[len] = 0;
    return(len);
}



// why rand works?
// simple, because it's a fixed function and not real random stuff:
//    seed = (seed * 0x343fd) + 0x269ec3;
//    return((seed >> 16) & 0x7fff);



int fulltilt_pwd(u8 *pwd, int pwdlen) {
    DWORD   volid,
            flags,
            maxlen;
    int     i,
            t,
            len;

    if(pwdlen < 5) return(-1);
    if(GetVolumeInformation(NULL, NULL, 0, &volid, &maxlen, &flags, NULL, 0)) {
        t = volid & 0xffff;
    } else {
        t = 0x0ff00ff;
    }
    srand(t);
    t = ((volid >> 16) & 0x1f) + (pwd[0] | (pwd[1] << 8)) + 1;
    for(i = 0; t > 0; t--) {
        i = rand();
    }
    if(i != (pwd[2] | (pwd[3] << 8))) return(-1);

    len = pwd[4];
    if(len >= 0x40) return(-1);
    if(len > pwdlen) return(-1);

    for(i = 0; i < len; i++) {
        t = rand() ^ pwd[5 + i];
        pwd[i] = t;
    }
    pwd[i] = 0;
    return(0);
}


